/* $Header */

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>
#include "exports.h"
#include "cwstart.h"


LIBMAIN

void DLL 
_init()
{
	LibExport( "void MarkExtendSelMotion UINT LPSTR");
}

/* Public functions:
 **
 * MarkExtendSelMotion: Extend/create a selection to the cursor
 * position that results from an API call.
 *
 * If a selection type other than SELECTION_NONE is given, then
 * a new selection is created of the given type beginning at the
 * current cursor position.  If SELECTION_NONE is given, then
 * the current selection is extended.  If there is no current
 * selection and SELECTION_NONE is given, then no selection is
 * created.
 *
 */

void DLL
MarkExtendSelMotion(UINT newMarkType, LPSTR func)
{
	LPSelection selp;
	UINT oldMarkType;

	if (!(selp = MemAlloc(sizeof(Selection))))
		return;
	oldMarkType = MarkGetSelInfo(selp, TRUE);
	MarkRemoveSel();
	if (!oldMarkType)
	{
		selp->begin.line = BufQCurrentLine();
		selp->begin.column = BufQCurrentCol();
	}
	if (!newMarkType)
		if (oldMarkType)
			newMarkType = oldMarkType;
		else
			newMarkType = SELECTION_EXCLUSIVE;

	LibFunctionExec(func);	
	MarkSavePos();
	MovAbs(selp->begin.line, selp->begin.column);
	MarkBeginSel(newMarkType);
	MarkRestorePos();
	MarkEndSel();
	MemFree(selp);
}

